unit Utils;

interface

uses windows,sysutils,math;

type
  SetOfChar = Set of char;
  SetOfByte = set of byte;
  TArrayOfStrings = array[0..MaxInt div sizeof(String)-1] of string;
  PArrayOfInteger = ^TArrayOfInteger;
  TArrayOfInteger = array[0..MaxInt div sizeof(Integer)-1] of Integer;
  pArrayOfStrings = ^TArrayOfStrings;
  pArrayOfTHandle = ^TArrayOfTHandle;
  TArrayOfTHandle = Array [0..MaxInt div sizeof(THandle)-1] of THandle;
  IntegerAsSet = set of 0..31;

function ShortDump(const it : array of Byte) : String;
procedure ErrMsg(const Msg : String);
procedure RaiseMsg(const Msg : String);
function ChangeChar(const S : String;From,ToChar : char) : String;
function ChangeSubStr(const S,From,ToStr : String) : String;
function ROL(It : longint;per : byte) : longint;
function SubStrBefore(const stng,dlm : String):String;
function SubStrAfter(const stng,dlm : String):String;
function PosChars(const chrs : SetOfChar;const Str : String) : integer;
function InString(const inSet : SetOfChar;const from : String) : boolean;
function UniqueByte(var from : SetOfByte) : byte;
procedure HaltWithMessage(const msg : String);
function RPos(const Substr : String;s: String): Integer;
function Position(const Substr,s : String;n : integer): Integer;
function LongPack(const ad : array of Word;const ab : array of byte) : Longint;
procedure LongUnPack(var ad : array of Word;const ab : array of byte;
it : longint);
function GreatestCommonDivisorInt(a1,a2 : integer) : integer;
function DelChars(const Str : String;const chrs : SetOfChar) : string;
function Int2Str(it,len : integer) : String;
function AnswerYes(const title,msg : String) : boolean;
function StrEqualTo(const Str : String;Strs : array of String) : integer;
function FindSintaxDelimiter(instr : String;del,Amp : char) : integer;
function IntToBin(Value,Digits : integer) : string;
function ind : char;
function Str2Seconds(const timestr : String) : integer;
function Seconds2Str(secs : integer) : String;
function CompareVar(v1,v2 : Variant) : integer;
function findbyte(const mem : array of byte; b : byte) : integer;
function IsIntersected(a1,a2,b1,b2 : double) : boolean;
function TruncToSmallInt(it : integer) : SmallInt;
function AnsiToOEM(ans : string) : String;
function left(s : String;len : integer) : String;
function right(s : String;len : integer) : String;
{$IFDEF WIN32}
//function EqualMem(P1, P2: Pointer; Length: Integer): Boolean;
procedure ExchangeMem(var m1,m2; length : integer);
{$ENDIF}
function Hypot(X, Y: Extended): Extended;
function Code(it : String) : String;
function DeCode(it : String) : String;
function SetToStr(const s;maxe : integer) : String;
function StringToSetOfByte(From : String) : SetOfByte;
function SetOfByteToString(const SetB : SetOfByte) : String;
function CheckHandle(it :tHandle) : tHandle;
procedure Execute(const cmd : String);
function ExecWait(const cmd : String;WaitFor : boolean) : integer;
function ExecWaitAsUser(h : THandle;const cmd : String;WaitFor : boolean) : integer;
function CmdParams : String;
function reord(it : LongInt):Longint;
function BitScanForward(from : integer) : integer;
procedure HitAnyKey;
function BitsViaMask(it,mask,value : integer) : integer;
procedure breakpoint;
procedure nop;
function IntFromBits(const als : array of integer;idx : integer) : integer;
function Intersect(a1,a2,b1,b2 : double) : double;
procedure SetTo(var sb : SetOfByte; it : integer; value : boolean);
function IsLike(It,Sh : String) : Boolean;

const
  Alpha = ['A'..'Z', 'a'..'z', '0'..'9', '_'];
  Numeric = ['0'..'9'];
  AlphaNumeric = Alpha+Numeric;
  AllChars = [low(char)..high(char)];
  MinShowTime = 2+1/24/60/60;
  MinDateTime : TDateTime = 0;
  MaxDateTime : TDateTime = 2958465.99998842599;
  ChkBool : function(RetVal: BOOL): BOOL =  Win32Check;

function MaxShowTime : TDateTime;

implementation

function IsPosSome(Some : char;const ShStr,It : String;idx : integer) : boolean;
var
  i : integer;
begin
  result := false;
  for i := 1 to length(ShStr) do
    if (it[i+idx-1]<>ShStr[i]) and (ShStr[i]<>Some) then exit;
  result := true;
end;

function PosSome(Some : char;SubStr,It : String) : integer;
begin
  for result:=1 to length(it)-length(SubStr)+1 do
    if IsPosSome(Some,SubStr,it,result) then exit;
  result := 0;
end;

function Is_Like(it,Sh : String;Any,Some : char) : boolean;
var
  i: integer;
  first,last : boolean; //Substrings between Any
  BeforeAny : String;
procedure SetBeforeAny;
var
  ai : integer;
begin
  ai := pos(Any,Sh);
  if ai=0 then begin
    BeforeAny := Sh;
    last := true;
    Sh := '';
  end else begin
    BeforeAny := Copy(Sh,1,ai-1);
    Sh := Copy(Sh,ai+1,MaxInt);
  end;
end;

begin
  first := true;
  result := false;
  last := false;
  repeat
    SetBeforeAny;
    i := PosSome(Some,BeforeAny,it);
    if (i=0)
    or first and (i<>1)
    or last and not IsPosSome(Some,BeforeAny,it,{i<>} length(it)-length(BeforeAny)+1) then exit;
    first := false;
    it := Copy(it,i+length(BeforeAny),MaxInt);
  until Sh='';
  result := true;
end;

function IsLike(it,Sh : String):boolean;
const
  Any = '%';
  Some = '_';
begin
  result := Is_Like(it,Sh,Any,Some);
end;

function BitScanForward(from : integer) : integer;
asm
  BSF EAX,FROM
  JNZ @@2
  mov eax,-1;
  @@2:
end;

function BitsViaMask(it,mask,value : integer) : integer;
begin
  result := it and not Mask or Value and Mask;
end;

function IntFromBits(const als : array of integer;idx : integer) : integer;
var
  cl : integer;
begin
  result := 0;
  for cl := low(als) to high(als) do
    result := result shl 1 or ord(idx in IntegerAsSet(als[cl]));
end;

procedure SetTo(var sb : SetOfByte; it : integer; value : boolean);
begin
  if value then include(sb,it)
  else exclude(sb,it);
end;

procedure nop;
begin
end;

procedure breakpoint;
asm
  int 3
end;

function GreatestCommonDivisorInt(a1,a2 : integer) : integer;
asm
//  mov eax,a1 // it is necessary
//  mov edx,a2 // only for stdcall
  @@1:
  mov ebx,edx
  cdq
  idiv ebx
  mov eax,ebx
  test edx,edx
  jnz @@1
end;

procedure HitAnyKey;
var
  nc : DWORD;
  h : THandle;
  cinp : TINPUTRECORD;
begin
  writeln('     ...');
  h := CheckHandle(GetStdHandle(STD_INPUT_HANDLE));
  ChkBool(FlushConsoleInputBuffer(h));
  repeat ChkBool(BOOL(ReadConsoleInput(h,cinp,sizeof(cinp),nc)));
    write(ind+#13);
  until cinp.EventType=Key_Event;
end;

function CmdParams : String;
var
  cn : integer;
begin
  result := '';
  for cn := 1 to ParamCount do
    appendStr(result,ParamStr(cn)+' ')
end;

function CheckHandle(it :tHandle) : tHandle;
begin
  ChkBool(it<>INVALID_HANDLE_VALUE);
  result := it;
end;

procedure Execute(const cmd : String);
begin
  ExecWait(cmd,false);
end;

function ExecWait(const cmd : String;WaitFor : boolean) : integer;
var
  PROCINF : TProcessInformation;
  Si : tStartupInfo;
  res : dword;
begin
  fillchar(si,sizeof(si),0);
  ChkBool(CreateProcess(nil,PChar(cmd),
  nil,nil,false,CREATE_DEFAULT_ERROR_MODE+NORMAL_PRIORITY_CLASS,nil,nil,si,PROCINF));
  if WaitFor then begin
    ChkBool(WaitForSingleObject(ProcInf.hProcess,INFINITE)<>WAIT_Failed);
    ChkBool(GetExitCodeProcess(ProcInf.hProcess,res));
    result := Res;
  end else result := 0;
  ChkBool(CloseHandle(ProcInf.hThread));
  ChkBool(CloseHandle(ProcInf.hProcess));
end;

function ExecWaitAsUser(h : THandle;const cmd : String;WaitFor : boolean) : integer;
var
  PROCINF : TProcessInformation;
  Si : tStartupInfo;
  res : dword;
begin
  fillchar(si,sizeof(si),0);
  ChkBool(CreateProcessAsUser(h,nil,PChar(cmd),
  nil,nil,false,CREATE_DEFAULT_ERROR_MODE+NORMAL_PRIORITY_CLASS,nil,nil,si,PROCINF));
  if WaitFor then begin
    ChkBool(WaitForSingleObject(ProcInf.hProcess,INFINITE)<>WAIT_Failed);
    ChkBool(GetExitCodeProcess(ProcInf.hProcess,res));
    result := res;
  end else result := 0;
  ChkBool(CloseHandle(ProcInf.hThread));
  ChkBool(CloseHandle(ProcInf.hProcess));
end;

function SetToStr(const s;maxe : integer) : String;
var
  cn : integer;
begin
  result := '';
  for cn:=0 to maxe do
    if cn in SetOfByte(s) then AppendStr(result,inttostr(cn)+',');
  if result<>'' then setlength(result,length(result)-1);
end;

function ChangeSubStr(const S,From,ToStr : String) : String;
var
  p : integer;
begin
  result := s;
  p := pos(from,s);
  if p=0 then exit;
  delete(result,p,length(from));
  insert(ToStr,result,p);
end;

function left(s : String;len : integer) : String;
begin
  result := s;
  if length(s)<len then
    appendStr(result,StringOfChar(' ',len-length(s)));
end;

function right(s : String;len : integer) : String;
begin
  if length(s)<len then
    result := StringOfChar(' ',len-length(s))+s
  else result := s;
end;

function reord(it : LongInt):Longint; assembler;
asm
  mov eax,it
  xchg ah,al
  rol eax,16
  xchg ah,al
end;

function Hypot(X, Y: Extended): Extended;
asm
        FLD     Y
        FABS
        FLD     X
        FABS               //X -> ST; Y -> ST(1)
        FCOM              // ?(X-Y)
        FNSTSW  AX
        TEST    AH,$41
        JNZ      @@1        // if ST > ST(1) then swap
        FXCH    ST(1)      // put larger number in ST(1)
@@1:    FLDZ
        FCOMP
        FNSTSW  AX
        TEST    AH,$1      // if ST = 0, return ST(1)
        JNZ      @@2
        FSTP    ST         // eat ST(0)
        JMP     @@3
@@2:    FDIV    ST,ST(1)   // ST := ST / ST(1)
        FMUL    ST,ST      // ST := ST * ST
        FLD1
        FADD               // ST := ST + 1
        FSQRT              // ST := Sqrt(ST)
        FMUL               // ST(1) := ST * ST(1); Pop ST
@@3:    FWAIT
end;

function Code(it : String) : String;
var
  k : record case byte of
    0 : (a0,a1 : byte);
    1 : (d : TDateTime);
  end;
  cn : integer;
begin
{  if it='' then begin
    result := '';
    exit;
  end;}
  k.d := Now;
  setlength(result,length(it)+2);
  for cn := 1 to length(it) do begin
    inc(k.a0,k.a1);
    result[cn] := char(ord(it[cn]) xor k.a0);
  end;
  result[length(it)+1] := char(k.a0);
  result[length(it)+2] := char(k.a1);
end;

function DeCode(it : String) : String;
var
  a0,a1 : byte;
  cn : integer;
begin
  if it='' then begin
    result := '';
    exit;
  end;
  setlength(result,length(it)-2);
  a0 := ord(it[length(it)-1]);
  a1 := ord(it[length(it)]);
  for cn := length(result) downto 1 do begin
    result[cn] := char(ord(it[cn]) xor a0);
    dec(a0,a1);
  end;
end;

function MaxShowTime : TDateTime;
begin
  result := Trunc(Now+1.1)+1/24/60/60;
end;

function AnsiToOEM(ans : string) : String;
begin
  setlength(result,length(ans));
  CharToOEM(pchar(ans),pchar(result));
end;

function TruncToSmallInt(it : integer) : SmallInt;
begin
  if it>High(SmallInt) then result := High(SmallInt)
  else
  if it<Low(SmallInt) then result := Low(SmallInt)
  else result := it;
end;

function Str2Seconds(const timestr : String) : integer;
begin
  result := round(StrToTime(timestr)*(24*60*60));
end;

function CompareVar(v1,v2 : Variant) : integer;
begin
  if VarType(v1)=VarString then result := CompareStr(v1,v2)
  else if v1>v2 then result := 1
  else if v1<v2 then result := -1
  else result := 0;
end;

function Seconds2Str(secs : integer) : String;
begin
  if secs>=24*60*60 then
    result := DateTimeToStr(secs/(24*60*60))
  else
    result := TimeToStr(secs/(24*60*60))
end;

{$ifNdef Win32}
procedure SetLength(var S : string; len : integer);
begin
  s[0] := char(len);
end;
{$endif}

function IntToBin(Value,Digits : integer) : string;
begin
  result := '';
  repeat
    Insert(inttostr(value and 1),result,1);
    value := value shr 1;
    Dec(Digits);
  until (Value=0) and (Digits<=0);
end;

function StrEqualTo(const Str : String;Strs : array of String) : integer;
begin
  for result := low(strs) to high(strs) do begin
    if str=strs[result] then exit;
  end;
  result := -1;
end;

function PosChars(const chrs : SetOfChar;const Str : String) : integer;
begin
  for result := 1 to length(Str) do
    if Str[result] in chrs then exit;
  result := 0;
end;

function FindSintaxDelimiter(instr : String;del,Amp : char) : integer;
var
  BeenAmp : boolean;
begin
  BeenAmp := false;
  result := 1;
  while result<=length(instr) do begin
    if (instr[result]=del) and not BeenAmp then Exit;
    if instr[result]=Amp then BeenAmp := not BeenAmp;
    inc(result);
  end;
  result := 0;
end;

function FindNumeric(From : String;var len : integer) : integer;
var
  i : integer;
begin
  result := PosChars(Numeric,From);
  if result=0 then exit;
  i := PosChars(AllChars-Numeric,Copy(From,result,MaxInt));
  if i=0 then len := length(from)-result+1
  else len := i-1;
  if (result>1) and (from[result-1]='-')  then begin
    dec(result);
    inc(len);
  end;
end;

const  s2sd = '-';

function StringToSetOfByte(From : String) : SetOfByte;
var
  idel,inum,nlen : integer;
  cval,Prev : integer;
begin
   result := [];
   prev := 0;
   repeat
     idel := Pos(s2sd,From);
     inum := FindNumeric(From,nlen);
     if inum=0 then break;
     if (s2sd='-') and (idel=1) and (result<>[]) then begin
       inc(inum);
       dec(nlen);
     end;
     cval := StrToInt(copy(From,inum,nlen));
     if (idel>0)and(idel<inum) then
       result := result + [prev..cval]
     else begin
       include(result,cval);
       prev := cval;
     end;
     from := copy(from,inum+nlen,MaxInt);
   until false;
end;

function SetOfByteToString(const SetB : SetOfByte) : String;
var
  cn : integer;
  d : String;
  scn : integer;
procedure ChkEnd;
begin
   if scn=2 then AppendStr(result,d+IntToStr(cn-1))
   else if scn>2 then AppendStr(result,s2sd+IntToStr(cn-1));
   scn := 0;
end;

begin
  result := '';
  d := '';
  scn := 0;
  for cn := low(byte) to high(byte) do
    if cn in SetB then begin
      if scn=0 then AppendStr(result,d+IntToStr(cn));
      d := ',';
      inc(scn);
    end else ChkEnd;
  ChkEnd;
end;

function IsIntersected(a1,a2,b1,b2 : double) : boolean;
begin
  result := (a1<b2) and (b1<a2)
  //and a1<a2 and b1<b2
  ;
end;

function Intersect(a1,a2,b1,b2 : double) : double;
begin
  if (a1<b2) and (b1<a2) then begin
    case ord(a1<b1) shl 1 + ord(a2<b2) of
    0 : result := b2-a1;      //  b1 a1  b2 a2
    1 : result := a2-a1;      //  b1 a1 a2 b2
    2 : result := b2-b1;      //  a1 b1 b2 a2
    3 : result := a2-b1;      //  a1 b1 a2 b2
    else raise Exception.Create('Program_Error');
    end;
  end else result:=0;
  //and a1<a2 and b1<b2;
end;

procedure RaiseMsg(const Msg : String);
begin
  raise Exception.Create(Msg);
end;

function ShortDump(const it : array of Byte) : String;
var
  cn : integer;
begin
  result := '';
  if sizeof(it)=0 then exit;
  for cn := low(it) to high(it) do
    AppendStr(result,IntToHex(it[cn],2)+' ');
end;

var
  cd : integer = 0;

function ind : char;
const
  aind : array[0..3] of char = '\|/-';
begin
  inc(cd);
  result := aind[cd and High(aind)];
end;

function AnswerYes(const title,msg : String) : boolean;
begin
  result := MessageBox(0,PChar(msg),PChar(title),MB_YESNO)=IDYES;
end;

function Int2Str(it,len : integer) : String;
begin
  Str(it:len,Result);
  result := ChangeChar(Result,' ','0');
end;

function DelChars(const Str : String;const chrs : SetOfChar) : String;
var
  cl : integer;
begin
  result := Str;
  cl := length(result);
  while cl>0 do begin
    if result[cl] in chrs then begin
      move(result[cl+1],result[cl],length(result)-cl);
      SetLength(result,length(result)-1);
    end;
    dec(cl);
  end;
end;

function ChangeChar(const S : String;From,ToChar : char) : string;
var
  cn : integer;
begin
  result := S;
  if result<>'' then
  for cn := 1 to length(S) do
    if result[cn]=From then result[cn] := ToChar;
end;

function LongPack(const ad : array of Word;const ab : array of byte) : Longint;
var
  cn : integer;
begin
  result := 0;
  cn := low(ad);
  repeat
    result := (result or ad[cn]);
    if cn<High(ad) then
      result := result shl ab[cn]
    else exit;
    inc(cn);
  until false;
end;

procedure LongUnPack(var ad : array of Word;const ab : array of byte;
it : longint);
var
  cn : integer;
begin
  cn := high(ad);
  repeat
    ad[cn] := it and (1 shl ab[cn] -1);
    if cn>Low(ad) then
      it := it shr ab[cn]
    else exit;
    dec(cn);
  until false;
end;

function RPos(const Substr : String;s: String): integer;
var
  tmp : integer;
begin
  tmp := 0;
  repeat
    result := tmp;
    tmp := pos(SubStr,s);
    s := copy(s,tmp,255);
  until tmp=0;
end;

function Position(const Substr,s : String;n : integer): Integer;
var
  dinc,stop : integer;
begin
  if n>0 then begin
    result:=0;
    dinc:=1;
    stop := length(s)-length(substr)+1;
  end else begin
    result := length(s)-length(substr)+2;
    dinc := -1;
    stop := 1;
  end;
  repeat
    inc(result,dinc);
    if CompareStr(Copy(S,result,length(substr)),SubStr)=0 then begin
       dec(n,dinc);
       if n=0 then exit;
    end;
  until result=stop;
  result := 0;
end;

function InString(const inSet : SetOfChar;const from : String) : boolean;
begin
  result := PosChars(inSet,from)<>0;
end;

function findbyte(const mem : array of byte; b : byte) : integer;
var
  cn : integer;
begin
  for cn := low(mem) to High(mem) do begin
    if mem[cn]=b then begin
      result := cn;
      exit;
    end;
  end;
  result := -1;
end;

{$ifdef Win32}
function EqualMem(P1, P2: Pointer; Length: Integer): Boolean; assembler;
asm
        PUSH    ESI
        PUSH    EDI
        MOV     ESI,P1
        MOV     EDI,P2
        MOV     EDX,ECX
        XOR     EAX,EAX
        AND     EDX,3
        SHR     ECX,2
        REPE    CMPSD
        JNE     @@2
        MOV     ECX,EDX
        REPE    CMPSB
        JNE     @@2
@@1:    INC     EAX
@@2:    POP     EDI
        POP     ESI
end;

procedure ExchangeMem(var m1,m2; length : integer); assembler;
asm
        PUSH    ESI
        PUSH    EDI
        MOV     ESI,M1
        MOV     EDI,M2
        MOV     EDX,ECX
        AND     EDX,3
        SHR     ECX,2
@@1:    mov EAX,[edi]
        movsd
        mov [esi-4],EAX
        loop @@1
        OR EDX,EDX
        JZ @@3
        MOV     ECX,EDX
@@2:    mov al,[edi]
        movsb
        mov [esi],al
        loop @@2
@@3:    POP     EDI
        POP     ESI
end;


{$endif}

function ROL(It : longint;per : byte) : longint;
{$ifdef CPU386}
assembler;
asm
  mov eax,it
  mov cl,per
  rol eax,cl
end;
{$else}
begin
  runerror(211);
end;
{$endif}


function UniqueByte(var from : SetOfByte) : byte;
begin
  result := low(result);
  while result<=high(result) do begin
    if not (result in from) then begin
      include(from,result);
      exit;
    end;
    inc(result);
  end;
end;

function SubStrBefore(const stng,dlm : String):String;
var
  posd : integer;
begin
  result := stng;
  posd := pos(dlm,result);
  if posd>0 then SetLength(Result,posd-1);
end;

function SubStrAfter(const stng,dlm : String):String;
var
  posd : integer;
begin
  posd := pos(dlm,stng);
  if posd>0 then result := copy(stng,posd+length(dlm),255)
  else result := '';
end;

procedure ErrMsg(const Msg : String);
const
  cerr = '';
begin
  if Msg='' then Exit;
  MessageBox(0,pChar(Msg),cerr,MB_ICONSTOP+MB_OK);
end;

procedure HaltWithMessage(const msg : String);
begin
  ErrMsg(msg);
  Halt;
end;

end.
